<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

/**
 * @property mixed video_type
 * @property mixed video_url
 * @property mixed images
 */
class ShippingRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('shippings'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules =
            [
                'image'=>'required',
                'min_order'=>'sometimes|nullable|numeric',
                'cities.*.tax'=>'required|numeric',
                'cities.*.country_id'=>'required|exists:countries,id',
                'cities.*.city_id'=>'required|exists:cities,id',
            ];
        if(request('min_order'))
        {
            $rules['discount'] = 'required|numeric|min:0|max:100';
        }

        foreach (languages() as $lang)
        {
            $lang_rules =
                [
                    // 'cities.*.timing_'.$lang->local=>'required',
                    'name_'.$lang->local=> 'required',
                ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('shippings');
        $local = getCurrentLocale();
        $attributes=[
            'image' => __('shippings.image'),
        ];

        if( !is_null( request('cities') ) )
        {
            $i = 0;
            foreach(request('cities') as $key=>$choice)
            {
                $choiceTitle =
                    [
                        'cities.'.$key.'.country_id' =>  __('shippings.country_id') .' '.($i+1),
                        'cities.'.$key.'.city_id' =>  __('shippings.city_id') .' '.($i+1),
                        'cities.'.$key.'.tax' =>  __('shippings.tax') .' '.($i+1),
                    ];
                $attributes = array_merge($attributes, $choiceTitle);
                
                ++$i;
            }
        }

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local => __('shippings.name') .' ' . $lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            parent::failedValidation($validator);
        }
    }
}
